﻿using System;

namespace ShapePolymorphism
{
    class Program
    {
        static void Main(string[] args)
        {
            //Shape s1 = new Shape(); // Shape 추상 클래스 또는 인터페이스의 인스턴스를 만들 수 없습니다.

            Shape s = new Circle(ShapeColor.Red, new ShapeRect(0, 0, 10, 30));
            s.draw();
            s = new Rectangle(ShapeColor.Green, new ShapeRect(30, 40, 50, 60));
            s.draw();
            s = new Triangle(ShapeColor.Blue, new ShapeRect(30, 40, 50, 60));
            s.draw();


            Shape[] shapeList = new Shape[5] {
                                        new Circle(ShapeColor.Red, new ShapeRect(0, 0, 10, 30)),
                                        new Rectangle(ShapeColor.Green, new ShapeRect(20, 30, 10, 30)),
                                        new Triangle(ShapeColor.Blue, new ShapeRect(30, 40, 20, 30)),
                                        new Square(ShapeColor.Blue, new ShapeRect(50, 60, 40, 50)),
                                        new Rectangle(ShapeColor.Blue, new ShapeRect(10, 20, 20, 30))
            };

            foreach (var e in shapeList)
            {
                e.draw();
            }

        }
    }
}
