﻿using System;
using System.Collections.Generic;

namespace ShapePolymorphism
{
    enum ShapeColor
    {
        Red, Green, Blue
    }
    class ShapeRect
    {
        public int x, y, width, height;
        public ShapeRect(int x, int y, int width, int height)
        {
            this.x = x;
            this.y = y;
            this.width = width;
            this.height = height;
        }
    }

    abstract class Shape
    {
        //ShapeColor fillColor;
        //ShapeRect bounds;

        public ShapeColor FillColor
        {
            get;
            set;
        }
        public ShapeRect Bounds
        {
            get;
            set;
        }
        public abstract void draw();
    }
}
